#!/usr/bin/perl

use Pg;

@experimente = ('build', 'pos_lkp', 'neg_lkp', 'delins' );

$header = 
"\\begin{tabular}{|D{.}{.}{2}!{\\vrule width 1pt}.|c!{\\vrule width 1pt}.|c!{\\vrule width 1pt}.|c!{\\vrule width 1pt}.|c!{\\vrule width 1pt}.|}\n" .
    "\\hline\n" .
    "& \\multicolumn{2}{c!{\\vrule width 1pt}}{\\scalebox{0.85}[1]{cuckoo-\$d\$-ary}} &\n" .
    "\\multicolumn{2}{c!{\\vrule width 1pt}}{\\scalebox{0.8}[1]{cuckoo-block}} &\n" .
    "\\multicolumn{2}{c!{\\vrule width 1pt}}{\\scalebox{0.65}[1]{cuckoo-block-impr.}} &\n" .
    "\\multicolumn{2}{c!{\\vrule width 1pt}}{cuckoo-lp} & \\multicolumn{1}{c|}{lp}\\\\\n" .
    "\\cline{2-10}\n" .
    "\\multicolumn{1}{|c!{\\vrule width 1pt}}{\\raisebox{1.5ex}[0pt][0pt]{\$\\varepsilon\$}} & \\multicolumn{1}{c|}{Zeit} & \$d\$ & \\multicolumn{1}{c|}{Zeit} & \$d\$ & \\multicolumn{1}{c|}{Zeit} & \$d\$ & \\multicolumn{1}{c|}{Zeit} & \$d\$ & \\multicolumn{1}{c|}{Zeit}\\\\\n" .
    "\\hline\n" ;

$footer = "\\hline\n\\end{tabular}\n";

$conn = Pg::connectdb("host=kt16.theoinf.tu-ilmenau.de dbname=cuckoo-experimente user=weidling password=gl_1984*");

foreach $experiment (@experimente) {
    $select = "select X.*, Y.$experiment  as \"lp time\" from (" .
	"select a.epsilon as epsilon, a.$experiment as \"d-ary time\", a.d as \"d-ary d\", " .
	"b.$experiment as \"block time\", b.d as \"block d\", " .
	"c.$experiment as \"block-improved time\", c.d as \"block-improved d\", ".
	"d.$experiment as \"cuckoo-lp time\", d.d as \"cuckoo-lp d\" ".
	"from min_$experiment a, min_$experiment b, min_$experiment c, min_$experiment d " .
	"where ".
	" a.name='cuckoo-dary' and b.name='cuckoo-block' and c.name='cuckoo-block-improved' and d.name='cuckoo-lp' " .
	"and ( a.epsilon between 0.49 and 0.51 or a.epsilon between 0.19 and 0.21 or a.epsilon between 0.095 and 0.105 or a.epsilon between 0.049 and 0.051 or a.epsilon between 0.019 and 0.021 or a.epsilon between 0.009 and 0.011 )" .
	"and a.epsilon=b.epsilon and a.epsilon=c.epsilon and a.epsilon=d.epsilon) as X ".
	"join data Y on X.epsilon=Y.epsilon where Y.verfahren=2";


    $result = $conn->exec( $select );
    $eps = 0;
    open(FILEWRITE, "> min-$experiment.include.tex");
    printf FILEWRITE $header;
    while( @row = $result->fetchrow ){
	if( $row[0] != $eps ){
	    $eps = $row[0];
	    print FILEWRITE $eps;
	    for( $i=1; $i < $result->nfields; $i++ ){
		print FILEWRITE ' & ', $row[$i];
	    }
	    print FILEWRITE "\\\\\n";
	}
    }
    printf FILEWRITE $footer;
    close FILEWRITE;
}
