#!/usr/bin/perl

use Pg;

@experimente = ('build', 'pos_lkp', 'neg_lkp', 'delins' );

$header = 
"\\begin{tabular}{|D{.}{.}{2}!{\\vrule width 1pt}.|c|.|c!{\\vrule width 1pt}.|c|.|c!{\\vrule width 1pt}.|c|.|c!{\\vrule width 1pt}.|c|.|c|}\n\\hline\n";
    
$header2 =
' & \multicolumn{4}{c!{\vrule width 1pt}}{Exp. 1} & \multicolumn{4}{c!{\vrule width 1pt}}{Exp. 2} & \multicolumn{4}{c!{\vrule width 1pt}}{Exp. 3} & \multicolumn{4}{c|}{Exp. 4}\\\\ \cline{2-17}' . 
'\raisebox{1.5ex}[0pt][0pt]{$\varepsilon$} & \multicolumn{2}{c|}{string} & \multicolumn{2}{c!{\vrule width 1pt}}{\scalebox{0.7}[1]{string-smalltable}} & \multicolumn{2}{c|}{string} & \multicolumn{2}{c!{\vrule width 1pt}}{\scalebox{0.7}[1]{string-smalltable}} & \multicolumn{2}{c|}{string} & \multicolumn{2}{c!{\vrule width 1pt}}{\scalebox{0.7}[1]{string-smalltable}} & \multicolumn{2}{c|}{string} & \multicolumn{2}{c|}{\\scalebox{0.7}[1]{string-smalltable}} \\\\ \hline'. 
"\n";

$footer = "\\hline\n\\end{tabular}\n";

$conn = Pg::connectdb("host=kt16.theoinf.tu-ilmenau.de dbname=cuckoo-experimente user=weidling password=gl_1984*");

@verfahren=(6, 10);


# $select = "select distinct epsilon from data where verfahren=$verf_mit or verfahren=$verf_ohne order by epsilon desc";
# $res_eps = $conn->exec( $select );
@epsilons = ( 0.5, 0.2, 0.1, 0.05, 0.02, 0.01 );


print $header;
print $header2;

# while( @r_eps = $res_eps->fetchrow ){
#  $eps = $r_eps[0];
foreach $eps(@epsilons){
  $eps_min=0.9999*$eps;
  $eps_max=1.00001*$eps;
  print $eps;
  foreach $experiment (@experimente) {
    foreach $v (@verfahren) {
      $select = "select round( cast($experiment as numeric),3), d from data where verfahren=$v and epsilon between $eps_min and $eps_max order by $experiment limit 1";
      $res = $conn->exec( $select );
      if( @row = $res->fetchrow ){
        print ' & ', $row[0], ' & ', $row[1];
      } else {
        print ' & &';
      }
    }
  }
  print "\\\\\n";
}
printf $footer;


